// Nazev:   Genrator hlidacich obvodu
// Soubor:  lex.cpp
// Popis:   implementace lexikalniho analyzatoru
// Datum:   2007-05-10
// Autor:   strakam@fit.vutbr.cz, Martin Straka, DIT 2007
//========================================================================

#include "lex.h"
//#include <iostream>
using namespace std;
int    section;
int    lexColumn,             // i-ty token na radku
       vect,
       lexLine;               // cislo radku
int    vector;      
string lexInt;                // obsahuje nactenou int hodnotu
string lexStr;                // obsahuje nacteny text (id,str)
static ifstream fin;          // vstupni soubor

//========================================================================

void radkovani(char c)         // pocita radky
{   if (c=='\n') {
      lexLine++;
      lexColumn=0;
}}

void pozice(char c)         // pocita radky
{   if (isspace(c)) lexColumn++;
}

bool lexInit(string inputFileName)   // otevre vstupni soubor
{  
   lexColumn = 0;
   lexLine = 1;
   lexInt = "";
   lexStr = "";
      vect=0;
   vector=0;
   fin.open(inputFileName.c_str());
   //fout.open(inputFileName.c_str());
   if (fin==NULL) { 
     cout << "Nelze otevrit vstupni soubor " << inputFileName;
     return 0;}
   else {
     cout << "Soubor " << inputFileName << " otevren..." << endl;
     //EndMarker(inputFileName);
     return 1;}
}

//------------------------------------------------------------------------------
void lexFree(string inputFileName)    // zavre vstupni soubor
{
   if (fin.is_open()) {
      fin.close();
      cout << endl << "Soubor " << inputFileName << " zavren...";
      }
}

//--------------------LEX analzyza----------------------------------------------
TSymbol lex() {
   lexInt = "";
   lexStr = "";
   lexColumn++; 
   vect=0;
   vector=0;
                   // pozice lexemu
    char c,nextc;
    c = ' ';
    nextc= ' ';    
    
    while (!fin.eof() && isspace(c)) {
    radkovani(c);
    fin.get(c);}
    
    if (isspace(c)) return eofSym;
    radkovani(c);
 
    //---------notepad-------------------------------------
        while (c=='/') {
           fin.get(c);
              if (c=='/'){
                do {
                  fin.get(c);
                } while (c != '\n');
            
            }
            radkovani(c);
            fin.get(c);
            while ((c == '\n') || isspace(c)) {
            radkovani(c);
            pozice(c);
            fin.get(c);}
         }//while notepad 
     
   
        //---------symboly-------------------------------------
        
        switch (c){
               case ';' :  return strednikSym;
               case '!' :  return negaceSym;
               case '(' :  return levazavoraSym;
               case ')' :  return pravazavoraSym;
               case ',' :  return carkaSym;
               case ':' :  return dvojteckaSym;
               case '@' :  return stavySym;
               case '#' :  return podminkySym;
               case '$' :  return eofSym;}

       //-------------porovnani << <> < >> > >= == = =< -----------
       if (c=='<' || c=='>' || c=='=') {
          TSymbol ven;
          fin.get(nextc);
          if (c=='<') {
             if (nextc=='=') return mensirovnoSym; 
             else
             if (nextc=='>') return ruznostSym; 
             else ven=mensiSym;}
          else
          if (c=='>') {
            if (nextc=='=') return vetsirovnoSym;
            else ven=vetsiSym;} 
          else
          if (c=='=') {
            if (nextc=='=') return rovnostSym;
            else ven=priradSym;}
        fin.putback(nextc);
        return ven;}//porovnani

        //---------ID-------------------------------------
        if ((c=toupper(c))=='_' || c>='A' && c<='Z')
           {
           while (c>='0' && c<='9' || c>='A' && c<='Z' || c=='_')
                 {
                 lexStr += c;
                 if (fin.eof()) break;
                 fin.get(c);
                 c=toupper(c);
                 }
            if (!(c>='0' && c<='9' || c>='A' && c<='Z' || c=='_')) fin.putback(c);
            if (lexStr=="AND") return andSym;
            if (lexStr=="OR") return orSym;
            else return idSym;
                       
        }//ID
        
        //-----------------ciselna konstanta----------------------
        if (c >= '0' && c <= '9')
          {
          while (c >= '0' && c <= '9')
                {
                vect++;
                if ( vect > 1) vector=1;
                lexInt+=c;
                if (fin.eof()) break;
                fin.get(c);
                }
      if (c<'0' || c>'9') fin.putback(c);
      return intkonstSym;
      }//konstanta
   lexTotalError("Neznamy symbol: " + int(c));
   return eofSym;
}//lex

//------------------------------------------------------------------------------
const string symbolCaptions[20] = {
   "$", "IntConst", "!", "(",
   ")", ";", ",", ":", "id",
   ">", "<", ">=", "<=", "==",
   "<>", "=", "@", "#", "AND", "OR"
};



//------------------------------------------------------------------------------
void lexTotalError(string msg)
{
   fprintf(stderr,"LexError[line=%d, column=%d]: %s \n", lexLine, lexColumn, msg.c_str());
 /*  fprintf(stderr," ~lexString = \"%s\"\n", lexStr.c_str());
   fprintf(stderr," ~lexInt    = \"%d\"\n", lexInt);*/
   exit(1);
}
//------------------------------------------------------------------------------
void synTotalError(string msg)
{
   fprintf(stderr,"SyntError[line=%d, column=%d]: %s\n", lexLine, lexColumn, msg.c_str());
   exit(1);
}
