// Nazev:   Genrator hlidacich obvodu
// Soubor:  parser.cpp
// Popis:   syntakticka analyza
// Datum:   2007-05-10
// Autor:   strakam@fit.vutbr.cz, Martin Straka, DIT 2007
//========================================================================
#include "parser.h"
#include "lex.h"
TSymbol sym;
string instate;
string prechod;
string signal;
string pomsignal;
string operace;
string intkonst;
string condoper;
//SYBMOL----------------------------------------------------------------
void expect(TSymbol s)       // porovna tokeny a vrati dalsi token
{
   if (sym == s)
      sym = lex();
   else
      { synTotalError("Syntakticka chyba, ocekavan symbol " + symbolCaptions[s]);}
}

//-----------------------------------------------------------------------
///////////////////SYNTAX////////////////////////////////////////////////
//PROGRAM----------------------------------------------------------------
void g_program()
{
   if (sym==stavySym) {
      sym=lex();
      g_conds();
      expect(podminkySym);
      g_states();
      sym=lex();
      if (sym==eofSym) cout << "Vstupni soubor zpracovan..."; 
   }
   else if (sym==eofSym) synTotalError("Spatny format: Vstupni soubor je prazdny");
   else synTotalError("Syntakticka chyba, program musi zacinat sybmolem @");
}

//STATES----------------------------------------------------------------
void g_states()
{
   if (sym==levazavoraSym) {
   sym=lex();
   g_state();
   g_states();
   }
   if (!(sym==eofSym)) synTotalError("Syntakticka chyba, ocekava se symbol (");
}

//STATE----------------------------------------------------------------
void g_state()
{
   instate="";
   if (sym==idSym) {
   instate=lexStr;
   // pridat do mnoziny stavu
   sym=lex();
   g_prechod();
   expect(pravazavoraSym);
   expect(dvojteckaSym);
     if (sym==idSym) 
     // pridat do mnoziny cilovych stavu
     add_state(instate,prechod,lexStr);
      
     else synTotalError("Syntakticka chyba, ocekava se identifikator NOVEHO STAVU");
   sym=lex();
   expect(strednikSym);
   }
   else synTotalError("Syntakticka chyba, ocekava se identifikator STAVU");
}

//PRECHOD----------------------------------------------------------------
void g_prechod()
{
   prechod="";
   if (sym==carkaSym){
      sym=lex();
      if (sym==idSym) {
        
        if (comp_sym(lexStr)) {
        prechod=lexStr;                     
         }
         else synTotalError("Chyba, prechod " + lexStr + " nebyl definovan!");
         
      sym=lex();
      }
   else synTotalError("Syntakticka chyba, ocekava se identifikator PRECHODU");
   }
   if (!(sym==pravazavoraSym)) synTotalError("Syntakticka chyba, ocekava se symbol ,");
}

//CONDS----------------------------------------------------------------
void g_conds()
{
   prechod="";
   condoper="";
   if (sym==idSym) {
   // pridat do mnoziny prechodu
     if (!comp_sym(lexStr)) {prechod=lexStr;}
     else synTotalError("Chyba vstupu, prechod " + lexStr + " uz existuje!");
         
   sym=lex();
   expect(priradSym);   
   g_vyraz();
   add_cond(condoper,signal,operace,intkonst);
   sym=lex();
   g_vyrazynext();
   expect(strednikSym);
   
   add_sym(prechod,read_cond());
   clear_cond();
   
   g_conds();
   }
   if (!(sym==podminkySym)) synTotalError("Syntakticka chyba, ocekava se identifikator vstupniho symbolu");
}

//VYRAZYNEXT----------------------------------------------------------------
void g_vyrazynext()
{
   condoper="";
   if (sym==andSym || sym==orSym) {
   if (sym==andSym) condoper="and"; else condoper="or";  
   sym=lex();
   g_vyraz();
   sym=lex();
   add_cond(condoper,signal,operace,intkonst);
   
   g_vyrazynext();
   }
   if (!(sym==strednikSym)) synTotalError("Syntakticka chyba, ocekava se klicove slovo AND nebo OR");
}


//VYRAZ----------------------------------------------------------------
void g_vyraz()
{
   signal="";
   if (sym==idSym) {
   // pridat signal do tabulky signalu entity
   pomsignal=lexStr;
   signal=lexStr;
   sym=lex();
   g_akce();
   }
   else synTotalError("Syntakticka chyba, ocekavan je identifikator signalu");
}

void g_akce()
{
   operace="";
   if (sym==vetsiSym) operace=">";
   else if (sym==mensiSym) operace="<";           
   else if (sym==vetsirovnoSym) operace=">=";           
   else if (sym==mensirovnoSym) operace="<=";
   else if (sym==rovnostSym) operace="=";
   else if (sym==ruznostSym) operace="/=";           
   else synTotalError("Syntakticka chyba, chyby operator porovnani");
   sym=lex();
   if (sym==intkonstSym) { 
      if (vector==0) {intkonst="'";
        intkonst+=lexInt;
        //cout << " Hodnota " << lexInt;
        intkonst+="'";
       //  cout << " Hodnota2 " << vect-1;
        }
   else {intkonst="\"";
        intkonst+=lexInt;
        //cout << " Hodnota " << lexInt;
        intkonst+="\"";
       // cout << " Hodnota2 " << vect-1;
        }
        if (!comp_sig(pomsignal)) add_sig(pomsignal,vect-1);
   }
   else synTotalError("Syntakticka chyba, chyby celociselna konstanta");
           
}


//------------------Spusteni syntaxe--------------------------------------------
void parse()
{
   sym = lex();
   g_program();
   
   //read_sig();
}//parse
