// Nazev:   Genrator hlidacich obvodu
// Soubor:  table.cpp
// Popis:   tabulka symbolu
// Datum:   2007-05-10
// Autor:   strakam@fit.vutbr.cz, Martin Straka, DIT 2007
//========================================================================
#include "table.h"
#include "lex.h"
using namespace std;


//---------Funkce pro praci se signaly------------------------------------
list<TSignal> SignalList;
list<TSignal>::iterator it_SignalList;
TSignal TableSign;
string pom;


bool comp_sig(string name)
{
        it_SignalList=SignalList.begin();
        while (it_SignalList!=SignalList.end()) {
          if ((*it_SignalList).name==name) return 1;
          it_SignalList++;}//while
       return 0;   
}

void add_sig(string name, int pomport)
{
              TableSign.name=name;
              TableSign.port=PORT;
              if (pomport==0) TableSign.typ=TYP;
              else {
              //cout << "Vektor" <<  pomport << "  "; 
              TableSign.typ=" std_logic_vector("+stringify(pomport)+" downto 0);";
             // cout << " std_logic_vector("+stringify(pomport-1)+" downto 0);";
             }
              SignalList.push_back(TableSign);
}
void read_sig()
{
        it_SignalList=SignalList.begin();
        while (it_SignalList!=SignalList.end()) {
//          f << (*it_SignalList).name << "    ";
//          f << (*it_SignalList).port;
//          f << (*it_SignalList).typ << endl;
          it_SignalList++;}//while
}

//---------Funkce pro praci se vstupnimi symboly------------------------------------
list<TSym> SymList;
list<TSym>::iterator it_SymList;
TSym TableSym;

bool comp_sym(string name)
{
        it_SymList=SymList.begin();
        while (it_SymList!=SymList.end()) {
          if ((*it_SymList).name==name) return 1;
          it_SymList++;}//while
       return 0;   
}

void add_sym(string name,string conds)
{
              TableSym.name=name;
              TableSym.conds=conds;
              SymList.push_back(TableSym);
}

void read_sym()
{
        it_SymList=SymList.begin();
        while (it_SymList!=SymList.end()) {
//          f << (*it_SymList).name << "    ";
//          f << (*it_SymList).port;
//          f << (*it_SymList).typ << endl;
          it_SymList++;}//while
}

//---------Funkce pro praci se stavy------------------------------------
list<TState> StateList;
list<TState>::iterator it_StateList;
list<TState>::iterator it_PomStateList;
TState TableState;

bool comp_state(string name)
{
        it_StateList=StateList.begin();
        while (it_StateList!=StateList.end()) {
          if ((*it_StateList).inname==name) return 1;
          it_StateList++;}//while
       return 0;   
}

void add_state(string inname,string prechod,string outname)
{
              TableState.inname=inname;
              TableState.outname=outname;
              TableState.prechod=prechod;
              StateList.push_back(TableState);
}

void read_state()
{
        
        it_StateList=StateList.begin();
        while (it_StateList!=StateList.end()) {
          (*it_StateList).inname;
          (*it_StateList).prechod;
          (*it_StateList).outname;
          it_StateList++;}//while
}

list<Tcond> CondList;
list<Tcond>::iterator it_CondList;
Tcond TableCond;

bool comp_cond(string name){
        it_CondList=CondList.begin();
        while (it_CondList!=CondList.end()) {
          if ((*it_CondList).signal==name) return 1;
          it_CondList++;}//while
       return 0;   
}

void add_cond(string condoper,string signal,string operace,string konstanta){
              TableCond.condoper=condoper;
              TableCond.signal=signal;
              TableCond.operace=operace;
              TableCond.konstanta=konstanta;
              CondList.push_back(TableCond);
}

string read_cond(){
string pom;
int poms;
       pom="";
       it_CondList=CondList.begin();
        while (it_CondList!=CondList.end()) {
          pom+=" ";    
          pom+=(*it_CondList).condoper;
          pom+=" ";
          pom+=(*it_CondList).signal;
          pom+=" ";
          pom+=(*it_CondList).operace;
          pom+=" ";
          pom+=(*it_CondList).konstanta;
          
          it_CondList++;}//while
          return pom;
          
}

void clear_cond(){
    CondList.clear();
}

//---------Vypisy------------------------------------
void instrukce_debugOut(string fn_out)
{
   string start;
   int count;
   int counts;
   ofstream f;
   f.open(fn_out.c_str());
   if (f==NULL)
      synTotalError("Nelze otevrit vystupni soubor");

        f << "--=================GENERATOR CHECKER in VHDL============" << endl;
        f << "library ieee;" << endl << "use ieee.std_logic_1164.all;" << endl
        << "use ieee.std_logic_arith.all;" << endl << "use ieee.std_logic_unsigned.all;" 
        << endl << endl;
        
     //--------ENTITY of Checker--------------------------------------   
        f << "--///////////////////// ENTITY of Guard /////////////////////" << endl;
        f << "entity GUARD is" << endl << "port(" << endl;
        f <<  "CLK        : in  std_logic;" << endl;
        f <<  "RESET      : in  std_logic;" << endl;
        
        it_SignalList=SignalList.begin();
        while (it_SignalList!=SignalList.end()) {
          f << (*it_SignalList).name << "    ";
          f << (*it_SignalList).port;
          f << (*it_SignalList).typ << endl;
          it_SignalList++;}//while
        
        
        f <<  "ERROR     : out std_logic );" << endl;
        f <<  endl << "end entity GUARD;" << endl << endl;       
        
        
     //--------ARCHITECTURE of Checker-------------------------------------- 
        f << "--///////////////////ARCHITECTURE of GUARD /////////////////////" << endl;
        f << "architecture FL_GUARD of GUARD is" << endl << endl;
        
        it_SymList=SymList.begin();
        while (it_SymList!=SymList.end()) {
          f << "signal   " << (*it_SymList).name << "  : std_logic;" << endl;
          it_SymList++;}//while
        f << endl;
        
        f << "type t_state is (";
        pom="";
        counts=1;
        it_StateList=StateList.begin();
        while (it_StateList!=StateList.end()) {
          if (counts==1) start=(*it_StateList).inname;
          if ((*it_StateList).inname!=pom) {
          f << (*it_StateList).inname << ",";
          pom=(*it_StateList).inname;
          }
          counts++;
          it_StateList++;}//while
        f << "Serr);" << endl;
        f << "signal present_state, next_state : t_state;" << endl << endl;
        
        f << "begin" << endl << endl;
        
        it_SymList=SymList.begin();
        while (it_SymList!=SymList.end()) {
          f << (*it_SymList).name << " <= '1' when";
          f << (*it_SymList).conds << endl;
          f << "    else '0';" << endl;
          it_SymList++;}//while
        f << endl; 
   
        
     //--------NEXT STATE LOGIC FSM---------------------------------------   
        f << "-- FSM present state register -------------------------" << endl;
        f << "sync_logic : process(RESET, CLK)" << endl;
        f << "begin" << endl;
        f << "  if (RESET = '"+RSTLOG+"') then" << endl;
        f << "     present_state <= "+start+";" << endl;
        f << "  elsif (CLK'event AND CLK = '"+CLKLOG+"') then" << endl;
        f << "     present_state <= next_state;" << endl;
        f << "  end if;" << endl;
        f << "end process sync_logic;" << endl << endl;
        
        
    //--------NEXT STATE LOGIC FSM---------------------------------------
        f << "-- FSM next state logic -------------------------------" << endl;
        f << "next_state_logic : process(present_state";
        it_SymList=SymList.begin();
        while (it_SymList!=SymList.end()) {
          f << ", "+(*it_SymList).name;
          it_SymList++;}//while
        f << ")" << endl;
        f << "begin" << endl;
        f << "  case present_state is" << endl;
        
        pom="";
        
        it_StateList=StateList.begin();
        while (it_StateList!=StateList.end()) {
          if ((*it_StateList).inname!=pom) {
            
            
            f << "    when "+(*it_StateList).inname+" =>" << endl;
            it_PomStateList=StateList.begin();
            count=1;
            while (it_PomStateList!=StateList.end()) {
              if ((*it_PomStateList).inname==(*it_StateList).inname) {
                if (count==1) f << "       if ("+(*it_PomStateList).prechod+" = '1') then" << endl;
                else  f << "       elsif ("+(*it_PomStateList).prechod+" = '1') then" << endl;
                f << "          next_state <= "+(*it_PomStateList).outname+";" << endl;
              count++;
              }//if 
            it_PomStateList++;}//while
            f << "       else" << endl; 
            f << "          next_state <= Serr;" << endl;
            f << "       end if;" << endl;
            }//if
            pom=(*it_StateList).inname;
            
            it_StateList++;}//while
        
        f << "    when Serr =>" << endl; 
        f << "       next_state <= "+start+";" << endl;
        
        f << "    when others =>" << endl; 
        f << "       next_state <= "+start+";" << endl;
        
        f << "  end case;" << endl;
        f << "end process next_state_logic;" << endl << endl;
   
        
    //--------OUTPUT LOGIC FSM--------------------------------------------
        f << "-- FSM output logic------------------------------------" << endl;
        f << "output_logic : process(present_state)" << endl;
        f << "begin" << endl;
        f << "  ERROR <= '0';" << endl;
        f << "  case present_state is" << endl;   
        f << "     when Serr => ERROR <= '1';" << endl;   
        f << "     when others => ERROR <= '0';" << endl;
        f << "  end case;" << endl;
        f << "end process output_logic;" << endl << endl;
        
        f << "end architecture FL_GUARD;";
        

   f.close();
}
      
