// Nazev:   Genrator hlidacich obvodu
// Soubor:  table.h
// Popis:   tabulka symbolu
// Datum:   2007-05-10
// Autor:   strakam@fit.vutbr.cz, Martin Straka, DIT 2007
//========================================================================
#ifndef tabulkaH
#define tabulkaH
#include "lex.h"
 #include <iostream>
 #include <sstream>
 #include <string>
 #include <stdexcept>
 
 class BadConversion : public std::runtime_error {
 public:
   BadConversion(const std::string& s)
     : std::runtime_error(s)
     { }
 };
 
 inline std::string stringify(double x)
 {
   std::ostringstream o;
   if (!(o << x))
     throw BadConversion("stringify(double)");
   return o.str();
 } 
 
using namespace std;

//-----typy constant-------------------------------------------------------
const string PORT = ": in";
const string TYP = " std_logic;";
const string RSTLOG = "1";
const string CLKLOG = "1";     

// ---Tabulka signalu----------------------------------------------------------
typedef struct{
    string name;
    string port;
    string typ;} TSignal;
extern list<TSignal> SignalList;
extern list<TSignal>::iterator it_SignalList;
extern TSignal TableSign;
//--------funkce---------------------------------------------------------------
bool comp_sig(string name);
void add_sig(string name, int pomport);
void read_sig();

// ---Tabulka signalu----------------------------------------------------------
typedef struct{
    string condoper;
    string signal;
    string operace;
    string konstanta;} Tcond;
extern list<Tcond> CondList;
extern list<Tcond>::iterator it_CondList;
extern Tcond TableCond;
//--------funkce---------------------------------------------------------------
string read_cond();
void add_cond(string condoper,string signal,string operace,string konstanta);
bool comp_cond(string name);
void clear_cond();

// ---Tabulka vstupnich symbolu----------------------------------------------------------
typedef struct{
    string name;
    string conds;
    } TSym;
extern list<TSym> SymList;
extern list<TSym>::iterator it_SymList;
extern TSym TableSym;
void read_sym();
void add_sym(string name,string conds);
bool comp_sym(string name);
// ---Tabulka stavu----------------------------------------------------------
typedef struct{
    string inname;
    string outname;
    string prechod;
    } TState;
extern list<TState> StateList;
extern list<TState>::iterator it_StateList;
extern list<TState>::iterator it_PomStateList;
extern TState TableState;
void read_state();
void add_state(string inname,string prechod,string outname);
bool comp_state(string name);


// -----------------------------------------------------------------------------
void instrukce_debugOut(string fn_out);
// -----------------------------------------------------------------------------

#endif

